CGButton_mt = {__index = CGButton}

-- Constructor
function CGButton:create()
	local new_inst = {pressed = false, mouse_over = false, dr = nil}
	
	setmetatable(new_inst, CGButton_mt)
	return new_inst
end

function CGButton:setText(t)
	local l = CGLabel:create(t)
	l.posX, l.posY = self.posX + 5, self.posY + 4
	local f = love.graphics.getFont()
	self.height = 20
	self.width = 10 + f:getWidth(t)
	self.dr = l
end

function CGButton:setImage(i)
	if self.width == 0 then self.width = 10 end
	if self.height == 0 then self.height = 10 end
	local c = CGCanvas:create(self.width, self.height)
	c.posX, c.posY = self.posX, self.posY
	c.resetAfterDraw = false
	c:paint({i, 0, 0, 0, self.width / i:getWidth(), self.height / i:getHeight()})
	self.dr = c
end

function CGButton:_onMouseDown(x,y,button)
	if (button == "l") then
		self.pressed = true
		self.mouse_over = true
	end
	if (self.onMouseDown) then self.onMouseDown(x,y,button) end
end

function CGButton:_onMouseUp(x,y,button)
	if (self.pressed and self.mouse_over) then
		if (self.click) then self.click() end
		self.pressed = false
	end
	if (self.onMouseUp) then self.onMousUp(x,y,button) end
end

function CGButton:_onMouseOver(x,y,d)
	self.mouse_over = true
	if (self.onMouseOver) then self.onMouseOver(x,y) end
end

function CGButton:_onMouseNotOver(x,y,d)
	self.mouse_over = false
	if (self.onMouseNotOver) then self.onMouseNotOver(x,y) end
end


function CGButton:draw()
	local mode = "line"
	if (self.pressed and self.mouse_over) then mode = "fill" end
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle(mode, self.posX, self.posY, self.width, self.height)
	love.graphics.setColor(255,255,255)
	if (self.dr) then self.dr:draw() end
end