CGCanvas_mt = {__index = CGCanvas}

-- Constructor
function CGCanvas:create(w,h)
	local new_inst = {canvas = love.graphics.newCanvas(w,h), resetAfterDraw = true, width = w, height = h}	
	setmetatable(new_inst, CGCanvas_mt)
	return new_inst
end

function CGCanvas:setSize(w,h)
	self.width = w
	self.height = h
	self.canvas = love.graphics.newCanvas(w,h)
end

function CGCanvas:paint(d_table)
	love.graphics.setCanvas(self.canvas)
	love.graphics.draw(unpack(d_table))
	love.graphics.setCanvas()
end

function CGCanvas:paint_func(func, args)
	love.graphics.setCanvas(self.canvas)
	func(unpack(args))
	love.graphics.setCanvas()
end


function CGCanvas:draw()
	love.graphics.draw(self.canvas, self.posX, self.posY)
	if self.resetAfterDraw then 
		self.canvas:clear()
	end
end