
CGPanel_mt = {__index = CGPanel}

-- Constructor
function CGPanel:create()
	local new_inst = {widgets = {}, bgColor = {r=255, g=255, b=255}}
	setmetatable(new_inst, CGPanel_mt)
	return new_inst
end

function CGPanel:addWidget(widget)
	table.insert(self.widgets, widget)
end

function CGPanel:removeWidget(widget)
	for k,v in ipairs(self.widgets) do
		if v == widget then
			table.remove(self.widgets, k)
			break
		end
	end
end

function CGPanel:_onMouseDown(x,y,button)
	for _,v in ipairs(self.widgets) do
		if (v.visible and v.active) then 
			if (v.posX+self.posX < x and v.posX+self.posX+v.width > x and
				v.posY+self.posY < y and v.posY+self.posY+v.height > y) then
				v:_onMouseDown(x-self.posX-v.posX,y-self.posY-v.posY,button)
				break
			end
		end
	end	
	if (self.onMouseDown) then self.onMouseDown(x-self.posX,y-self.posY,button) end
end

function CGPanel:_onMouseUp(x,y,button)
	for _,v in ipairs(self.widgets) do
		if (v.visible and v.active) then 
			if (v.posX+self.posX < x and v.posX+self.posX+v.width > x and
				v.posY+self.posY < y and v.posY+self.posY+v.height > y) then
				v:_onMouseUp(x-self.posX-v.posX,y-self.posY-v.posY,button)
				break
			end
			if (v.pressed) then v.pressed = false end
		end
	end	
	if (self.onMouseUp) then self.onMouseUp(x-self.posX,y-self.posY,button) end
end

function CGPanel:_onMouseOver(x,y,d)
	for _,v in ipairs(self.widgets) do
		if (v.visible and v.active) then 
			if (v.posX+self.posX < x and v.posX+self.posX+v.width > x and
				v.posY+self.posY < y and v.posY+self.posY+v.height > y) then
				v:_onMouseOver(x-self.posX-v.posX,y-self.posY-v.posY,d)
			else
				v:_onMouseNotOver(x-self.posX-v.posX,y-self.posY-v.posY,d)
			end
		end
	end	
	if (self.onMouseOver) then self.onMouseOver(x-self.posX,y-self.posY,d) end
end

function CGPanel:_onScrollUp(x,y,button)
	for _,v in ipairs(self.widgets) do
		if (v.visible and v.active) then 
			if (v.posX+self.posX < x and v.posX+self.posX+v.width > x and
				v.posY+self.posY < y and v.posY+self.posY+v.height > y) then
				v:_onScrollUp(x-self.posX-v.posX,y-self.posY-v.posY,button)
				break
			end
		end
	end	
	if (self.onScrollUp) then self.onScrollUp(x-self.posX,y-self.posY,button) end
end

function CGPanel:_onScrollDown(x,y,button)
	for _,v in ipairs(self.widgets) do
		if (v.visible and v.active) then 
			if (v.posX+self.posX < x and v.posX+self.posX+v.width > x and
				v.posY+self.posY < y and v.posY+self.posY+v.height > y) then
				v:_onScrollDown(x-self.posX-v.posX,y-self.posY-v.posY,button)
				break
			end
		end
	end	
	if (self.onScrollDown) then self.onScrollDown(x-self.posX,y-self.posY,button) end
end

function CGPanel:draw()
	if (not self.visible) then return nil end
	love.graphics.setColor(self.bgColor.r,self.bgColor.g,self.bgColor.b)
	love.graphics.rectangle("fill", self.posX, self.posY, self.width, self.height)
	love.graphics.setColor(255,255,255)
	love.graphics.push()
	love.graphics.translate(self.posX, self.posY)
	for _,v in ipairs(self.widgets) do
		if (v.visible) then v:draw() end
	end	
	love.graphics.pop()	
end