CGScrollbar_mt = {__index = CGScrollbar}

-- Constructor
function CGScrollbar:create(h)
	local new_inst = {maxValue = 250, value = 0, step = 1}
	new_inst.width = 20
	new_inst.height = h
	--Slider
	local obj = CGButton:create()
	obj.width, obj.height = 20, 20
	obj.posY = 20
	new_inst.slider = obj
	--Panel
	local obj = CGPanel:create()
	obj.bgColor={r=200, g=200, b=200}
	obj.width = 20
	obj.height = h
	obj.onMouseDown = function(x,y,button) 
		if (button == "l" and y > 20 and y < new_inst.height - 20) then
			local v = math.floor((y-25)/((new_inst.height-50)/new_inst.maxValue))
			v = math.max(math.min(v, new_inst.maxValue),0)
			if (v <= new_inst.maxValue and v >= 0) then
				new_inst.value = v
				new_inst:updateSlider()
			end
		end
	end
	new_inst.panel = obj
	--Button up
	obj = CGButton:create()
	obj.width, obj.height = 20, 20
	obj.click = function()
		new_inst.value = new_inst.value - new_inst.step
		if (new_inst.value < 0) then new_inst.value = 0 end
		new_inst:updateSlider()
	end
	new_inst.buttonUp = obj
	--Button down
	obj = CGButton:create()
	obj.width, obj.height = 20, 20
	obj.posY = new_inst.height-20
	obj.click = function()
		new_inst.value = new_inst.value + new_inst.step
		if (new_inst.value > new_inst.maxValue) then new_inst.value = new_inst.maxValue end
		new_inst:updateSlider()
	end
	new_inst.buttonDown = obj
	new_inst.panel:addWidget(new_inst.slider)
	new_inst.panel:addWidget(new_inst.buttonUp)
	new_inst.panel:addWidget(new_inst.buttonDown)
	
	setmetatable(new_inst, CGScrollbar_mt)
	return new_inst
end

function CGScrollbar:updateSlider()
	self.slider.posY = math.floor(self.value * (self.height - 60) / self.maxValue) + 20
end

function CGScrollbar:setValue(n)
	self.value = math.min(math.max(0,n), self.maxValue)
	self:updateSlider()
end

function CGScrollbar:setMaxValue(n)
	if (n >= 0) then
		self.maxValue = n
		if (self.value > self.maxValue) then self.value = self.maxValue end
		self:updateSlider()
	end
end

function CGScrollbar:_onMouseDown(x,y,button)
	self.panel:_onMouseDown(x,y,button)
	if (self.onMouseDown) then self.onMouseDown(x,y,button) end
end


function CGScrollbar:_onMouseUp(x,y,button)
	self.panel:_onMouseUp(x,y,button)
	if (self.onMouseUp) then self.onMouseUp(x,y,button) end
end

function CGScrollbar:_onMouseOver(x,y,d)
	self.panel:_onMouseOver(x,y,d)
	if (self.onMouseOver) then self.onMouseOver(x,y,d) end
end

function CGScrollbar:_onMouseNotOver(x,y,d)
	self.panel:_onMouseNotOver(x,y,d)
	if (self.onMouseNotOver) then self.onMouseNotOver(x,y,d) end
end

function CGScrollbar:_onScrollUp(x,y,button)
	self.buttonUp:click()
	if (self.onScrollUp) then self.onScrollUp(x,y,button) end
end

function CGScrollbar:_onScrollDown(x,y,button)
	self.buttonDown:click()
	if (self.onScrollDown) then self.onScrollDown(x,y,button) end
end

function CGScrollbar:draw()
	love.graphics.push()
	love.graphics.translate(self.posX, self.posY)
	self.panel:draw()
	love.graphics.pop()
end