CGTabs_mt = {__index = CGTabs}

-- Constructor
function CGTabs:create()
	local new_inst = {tabs={}, activeTab={}}
	setmetatable(new_inst, CGTabs_mt)
	return new_inst
end

function CGTabs:addTab(nam,p)
	local n = CGLabel:create(nam)
	--n.text = nam
	n.posY = self.posY + 5
	p.posX = self.posX
	p.posY = self.posY + 20
	p.width = self.width
	p.height = self.height - 20
	p.visible = false
	table.insert(self.tabs, {name=n, panel=p})
	if (# self.tabs == 1) then
		self.activeTab = self.tabs[1]
		p.visible = true
	end
	self:calculateTabs()
end

function CGTabs:removeTab(n)
	for _,v in ipairs(self.tabs) do
		if (v.name.text == n) then
			table.remove(self.tabs, v)
			break
		end
	end
	self:calculateTabs()
end

function CGTabs:calculateTabs()
	local f = love.graphics.getFont()
	local startX = self.posX + 5
	for _,v in ipairs(self.tabs) do
		v.name.posX = startX
		v.name.width = f:getWidth(v.name.text)
		startX = startX + 10 + v.name.width
	end
end

function CGTabs:_onMouseDown(x,y,button)
	if (self.posY<y and self.posY+20>y) then
		if (button == "l") then
			for _,v in ipairs(self.tabs) do	
				if (v.name.posX-4 < x and v.name.posX+v.name.width+4 > x and
					self.posY < y and self.posY+20 > y) then
					self.activeTab.panel.visible = false
					v.panel.visible = true
					self.activeTab = v
					break
				end				
			end
		end
	else
		self.activeTab.panel:_onMouseDown(x,y,button)
	end
	if (self.onMouseDown) then self.onMouseDown(x,y,button) end
end

function CGTabs:_onMouseUp(x,y,button)
	if (not (self.posY<y and self.posY+20>y)) then
		self.activeTab.panel:_onMouseUp(x,y)
	end
	if (self.onMouseUp) then self.onMouseUp(x,y) end
end

function CGTabs:_onMouseOver(x,y,d)
	if (not (self.posY<y and self.posY+20>y)) then
		self.activeTab.panel:_onMouseOver(x,y,d)
	end
	if (self.onMouseOver) then self.onMouseOver(x,y,d) end
end

function CGTabs:_onScrollUp(x,y,button)
	if (not (self.posY<y and self.posY+20>y)) then
		self.activeTab.panel:_onScrollUp(x,y,button)
	end
	if (self.onScrollUp) then self.onScrollUp(x,y,button) end
end

function CGTabs:_onScrollDown(x,y,button)
	if (not (self.posY<y and self.posY+20>y)) then
		self.activeTab.panel:_onScrollDown(x,y,button)
	end
	if (self.onScrollDown) then self.onScrollDown(x,y,button) end
end

function CGTabs:draw()
	love.graphics.setColor(self.activeTab.panel.bgColor.r,self.activeTab.panel.bgColor.g,self.activeTab.panel.bgColor.b)
	love.graphics.rectangle("fill", self.activeTab.name.posX-4, self.posY, self.activeTab.name.width+8, 20)
	love.graphics.setColor(255,255,255)
	for _,v in ipairs(self.tabs) do
		if (v ~= self.activeTab) then 
			love.graphics.setColor(self.activeTab.panel.bgColor.r*0.9,self.activeTab.panel.bgColor.g*0.9,self.activeTab.panel.bgColor.b*0.9)
			love.graphics.rectangle("fill", v.name.posX-4, self.posY, v.name.width+8, 20)
			love.graphics.setColor(255,255,255)
		end
		v.name:draw()
	end
	
	self.activeTab.panel:draw()
	
end